/*
  folderdelete Version 1.01
  Copyright (C) 2003  hdk (Hideki EIRAKU)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA

  -- 
  E-mail: hdk@SoftHome.net
*/

#include <windows.h>

HICON hicon;
HMENU hmenu;

TCHAR tiptext[32];

int mode;
int opt_h;

HWND (*SetHook)(HWND);
void (*ReleaseHook)(void);

HINSTANCE hinstance;

void
add (HWND hwnd)
{
  NOTIFYICONDATA tnd;

  tnd.cbSize = sizeof (NOTIFYICONDATA);
  tnd.hWnd = hwnd;
  tnd.uID = 1;
  tnd.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
  tnd.uCallbackMessage = WM_USER + 1;
  tnd.hIcon = hicon;
  CopyMemory (tnd.szTip, tiptext, sizeof (tiptext));
  if (Shell_NotifyIcon (NIM_ADD, &tnd))
    {
      ShowWindow (hwnd, SW_HIDE);
      mode = 1;
    }
  else
    ShowWindow (hwnd, SW_SHOW | SW_MINIMIZE);
}

void
del (HWND hwnd)
{
  NOTIFYICONDATA tnd;

  tnd.cbSize = sizeof (NOTIFYICONDATA);
  tnd.hWnd = hwnd;
  tnd.uID = 1;
  tnd.uFlags = 0;
  if (mode)
    mode = Shell_NotifyIcon (NIM_DELETE, &tnd) ? 0 : 2;
  ShowWindow (hwnd, SW_HIDE);
}

BOOL CALLBACK
aboutproc (HWND hwnd, UINT msg, WPARAM w, LPARAM l)
{
  if (msg == WM_INITDIALOG)
    {
      RECT rc;

      if (GetWindowRect (hwnd, &rc))
	{
	  rc.right -= rc.left;
	  rc.bottom -= rc.top;
	  SetWindowPos (hwnd, 0,
			(GetSystemMetrics (SM_CXSCREEN) - rc.right) / 2,
			(GetSystemMetrics (SM_CYSCREEN) - rc.bottom) / 2,
			0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	}
      return 1;
    }
  if (msg == WM_COMMAND)
    {
      switch (w)
	{
	case IDCANCEL:
	  EndDialog (hwnd, 0);
	  break;
	case 502:		/* URL */
	  {
	    TCHAR buf[256];

	    GetWindowText (GetDlgItem (hwnd, 502), buf, 256);
	    ShellExecute (hwnd, 0, buf, 0, TEXT (""), 0);
	  }
	  break;
	case 501:		/* Copy */
	  if (OpenClipboard (hwnd))
	    {
	      TCHAR *buf;
	      HGLOBAL hg;
	      HWND btn;
	      int ll;

	      btn = GetDlgItem (hwnd, 502);
	      hg = GlobalAlloc (GMEM_DDESHARE, sizeof (TCHAR) *
				(ll = (GetWindowTextLength (btn) + 1)));
	      if (hg)
		{
		  buf = GlobalLock (hg);
		  GetWindowText (GetDlgItem (hwnd, 502), buf, ll);
		  GlobalUnlock (hg);
		  EmptyClipboard ();
#if defined (UNICODE)
		  SetClipboardData (CF_UNICODETEXT, hg);
#else
		  SetClipboardData (CF_TEXT, hg);
#endif
		}
	      CloseClipboard ();
	    }
	  break;
	}
      return 1;
    }
  if (msg == WM_CONTEXTMENU)
    {
      HWND btn;

      btn = GetDlgItem (hwnd, 502);
      if ((HWND)w == btn)
	{
	  int x = 0, y = 0;
	  HMENU menu0, menu1;

	  if ((unsigned long int)l == 4294967295UL)
	    {
	      RECT rc;

	      if (GetWindowRect (btn, &rc))
		{
		  x = (rc.left + rc.right) / 2;
		  y = (rc.top + rc.bottom) / 2;
		}
	    }
	  else
	    {
	      x = LOWORD (l);
	      y = HIWORD (l);
	    }
	  menu0 = LoadMenu (hinstance, TEXT ("CONTEXT"));
	  menu1 = GetSubMenu (menu0, 0);
	  TrackPopupMenu (menu1, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON
			  | TPM_RIGHTBUTTON, x, y, 0, hwnd, 0);
	  DestroyMenu (menu0);
	}
      return 1;
    }
  return 0;
}

LRESULT CALLBACK
MainWndProc (HWND hwnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
  static UINT taskbarrestart = 0;

  switch (nMsg)
    {
    case WM_CREATE:
      taskbarrestart = RegisterWindowMessage (TEXT ("TaskbarCreated"));
      if (opt_h)
	del (hwnd);
      else
	add (hwnd);
      return 0;
    case WM_DESTROY:
      del (hwnd);
      PostQuitMessage (0);
      return 0;
    case WM_QUERYOPEN:
      return 0;
    case WM_USER:
      del (hwnd);
      if (!wParam)
	add (hwnd);
      return 0;
    case WM_USER + 1:
      if (lParam == WM_RBUTTONUP)
	{
	  static int flag = 0;
	  POINT	pt;

	  if (flag)
	    break;
	  flag = 1;
	  GetCursorPos (&pt);
	  if (!SetForegroundWindow (hwnd))
	    {
	      HWND h;
	      RECT rc;

	      h = CreateWindowEx (WS_EX_TOOLWINDOW, TEXT ("BUTTON"), TEXT (""),
				  WS_POPUP | WS_MINIMIZE, 0, 0, 0, 0, hwnd, 0,
				  hinstance, 0);
	      GetWindowRect (h, &rc);
	      SetWindowPos (h, 0, -rc.right, -rc.bottom, 0, 0, SWP_NOACTIVATE |
			    SWP_NOCOPYBITS);
	      ShowWindow (h, SW_SHOW);
	      SetForegroundWindow (h);
	      ShowWindow (h, SW_RESTORE);
	      SetForegroundWindow (hwnd);
	      DestroyWindow (h);
	      if (GetForegroundWindow () != hwnd)
		flag = 0;
	    }
	  if (flag)
	    {
	      TrackPopupMenu (hmenu,
			      TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			      pt.x, pt.y, 0, hwnd, 0);
	      flag = 0;
	    }
	}
      return 0;
    case WM_COMMAND:
      if (!HIWORD (wParam))
	{
	  SendMessage (hwnd, WM_SYSCOMMAND, LOWORD (wParam), 0);
	  return 0;
	}
      break;
    case WM_INITMENUPOPUP:
      if ((HMENU)wParam == hmenu)
	{
	  if (!IsWindowVisible (hwnd))
	    EnableMenuItem (hmenu, 0, MF_BYPOSITION | MF_GRAYED);
	  return 0;
	}
      break;
    case WM_SYSCOMMAND:
      if (wParam == 3)		/* about */
	{
	  EnableMenuItem (hmenu, 3, MF_BYCOMMAND | MF_GRAYED);
	  EnableMenuItem (hmenu, SC_CLOSE, MF_BYCOMMAND | MF_GRAYED);
	  DialogBox (hinstance, TEXT ("About"), hwnd, aboutproc);
	  EnableMenuItem (hmenu, SC_CLOSE, MF_BYCOMMAND | MF_ENABLED);
	  EnableMenuItem (hmenu, 3, MF_BYCOMMAND | MF_ENABLED);
	  return 0;
	}
      if (wParam == 4)		/* delete and add icon */
	{
	  del (hwnd);
	  add (hwnd);
	  return 0;
	}
      if (wParam == 5)		/* hide icon */
	{
	  del (hwnd);
	  return 0;
	}
      break;
    default:
      if (nMsg == taskbarrestart && taskbarrestart)
	{
	  del (hwnd);
	  if (!opt_h)
	    add (hwnd);
	}
    }

  return DefWindowProc (hwnd, nMsg, wParam, lParam);
}

int STDCALL
WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpCmd, int nShow)
{
  HWND hwnd;
  MSG msg;
  WNDCLASSEX wndclass;
  TCHAR classname[] = TEXT ("folderdelete");
  HANDLE hlib;

  hinstance = hInst;
  mode = 0;
  if (!lstrcmpiA (lpCmd, "hide"))
    opt_h = 1;
  else
    opt_h = 0;
  hicon = LoadIcon (hInst, TEXT ("MainIcon"));
  if (!LoadString (hInst, 1, tiptext, 32)) /* "folderdelete x.xx" */
    return 0;

  ZeroMemory (&wndclass, sizeof (wndclass));
  wndclass.cbSize = sizeof (WNDCLASSEX);
  wndclass.lpszClassName = classname;
  wndclass.style = 0;
  wndclass.lpfnWndProc = MainWndProc;
  wndclass.hInstance = hInst;
  wndclass.hIcon = hicon;
  wndclass.hIconSm = hicon;
  wndclass.hCursor = LoadCursor (0, IDC_ARROW);
  wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  if (!RegisterClassEx (&wndclass))
    return 0;

  hwnd = CreateWindow (classname, tiptext, WS_OVERLAPPED | WS_CAPTION
		       | WS_SYSMENU | WS_MINIMIZE, CW_USEDEFAULT,
		       CW_USEDEFAULT, 0, 0,
		       0, 0, hInst, 0);
  if (!hwnd)
    return 0;

  hlib = LoadLibrary (TEXT ("folderdeletedll"));
  if (hlib)
    {
      *((FARPROC *)&SetHook) = GetProcAddress (hlib, "SetHook");
      *((FARPROC *)&ReleaseHook) = GetProcAddress (hlib, "ReleaseHook");
      if (!SetHook || !ReleaseHook)
	{
	  FreeLibrary (hlib);
	  hlib = 0;
	}
      else
	{
	  HWND a;

	  a = SetHook (hwnd);
	  if (a)
	    {
	      DestroyWindow (hwnd);
	      if (a != INVALID_HANDLE_VALUE)
		PostMessage (a, WM_USER, opt_h, 0);
	      return 0;
	    }
	}
    }
  if (!hlib)
    {
      TCHAR errormes[128];

      DestroyWindow (hwnd);
      if (LoadString (hInst, 2, errormes, 128))	/* "Can't load ..." */
	MessageBox (0, errormes, 0, 0);
      return 0;
    }

  hmenu = GetSystemMenu (hwnd, FALSE);
  DeleteMenu (hmenu, 0, MF_BYPOSITION);
  DeleteMenu (hmenu, 1, MF_BYPOSITION);
  DeleteMenu (hmenu, 1, MF_BYPOSITION);
  DeleteMenu (hmenu, 1, MF_BYPOSITION);
  DeleteMenu (hmenu, 1, MF_BYPOSITION);
  {
    TCHAR buf[128];

    AppendMenu (hmenu, MF_SEPARATOR, 0, 0);
    if (!LoadString (hInst, 4, buf, 128)) /* "Delete and add icon" */
      buf[0] = 0;
    AppendMenu (hmenu, MF_STRING, 4, buf);
    if (!LoadString (hInst, 5, buf, 128)) /* "Hide icon" */
      buf[0] = 0;
    AppendMenu (hmenu, MF_STRING, 5, buf);
    if (!LoadString (hInst, 3, buf, 128)) /* "About" */
      buf[0] = 0;
    AppendMenu (hmenu, MF_STRING, 3, buf);
  }

  while (GetMessage (&msg, 0, 0, 0))
    {
      TranslateMessage (&msg);
      DispatchMessage (&msg);
    }

  if (hlib)
    {
      ReleaseHook ();
      FreeLibrary (hlib);
    }

  return msg.wParam;
}
